#include "header.h"


void line(SDL_Surface *s, int x0, int y0, int x1, int y1, Uint32 color) {
  int cont;
  
  float m = (y1 - y0) / (float)(x1 - x0);

  if (x0 == x1)  /* vertical line */
    for( cont = y0; cont != y1;  cont = (y0<y1)? cont+1 : cont-1 )
      putpixel(s, x0, cont, color);
  else {
    if (abs(y1 - y0) < abs(x1 - x0)) /* -1 < m < 1 */
      
      for (cont = x0; cont != x1; cont = (x0<x1)? cont+1 : cont-1 )
        putpixel(s,
                 cont,
                 (int)(m*(cont - x0) + y0),
                 color);
    
    else /* m < -1 or m > 1*/
    
      for (cont = y0; cont != y1; cont = (y0<y1)? cont+1 : cont-1 )
        putpixel(s,
               
                 (int)((m * x0 + cont - y0)/m),   
                 cont,
                 color);
  }
}

#define COLOR_LINE SDL_MapRGB(s -> format, 0, 40, 255)
#define COLOR_POINT SDL_MapRGB(s -> format, 0, 0, 255)
#define COLOR_BACKGROUND SDL_MapRGB(s -> format, 222, 222, 222)

#define UNIT_Y(i, j) (SIN30 * (scalai * (i) + scalaj * (j)))
#define UNIT_X(i, j) (COS30 * (scalaj * (j) - scalai * (i)))

#define ORIGINE_X (COS30 * scalaj * (M -> r - 1) + BORDER)
#define ORIGINE_Y 255 + BORDER

void matrix2image3d(SDL_Surface *s, int scalai, int scalaj, Matrice *M) {
  int i,j;
  
  /* clear Surface */ 
  SDL_FillRect(s, &background, COLOR_BACKGROUND);

  lockScreen(s);

  for (i = 0; i < M -> r; i++)
    for (j = 0; j < M -> c; j++) {
      if (i > 0)
        line(s,(int)(ORIGINE_X + UNIT_X(i,j)),
             (int)(ORIGINE_Y + UNIT_Y(i,j) - M->m[Ind(i,j)]),
             (int)(ORIGINE_X + UNIT_X(i-1, j)),
             (int)(ORIGINE_Y + UNIT_Y(i-1,j) - M->m[Ind(i-1,j)]),
             COLOR_LINE);
      
      if (j > 0)
        line(s,(int)(ORIGINE_X + UNIT_X(i,j)),
             (int)(ORIGINE_Y + UNIT_Y(i,j) - M->m[Ind(i,j)]),
             (int)(ORIGINE_X + UNIT_X(i, j-1)),
             (int)(ORIGINE_Y + UNIT_Y(i,j-1) - M->m[Ind(i,j-1)]),
             COLOR_LINE);
      putpixel(s,
               (int)(ORIGINE_X + UNIT_X(i,j)),
               (int)(ORIGINE_Y + UNIT_Y(i,j) - M->m[Ind(i,j)]),
               COLOR_POINT);
      
    }
  /*
  putpixel(s,(int)ORIGINE_X, (int)ORIGINE_Y,
           SDL_MapRGB(s -> format, 255, 0, 0));
  */
  unlockScreen(s);
}
