/* include */

#ifndef HEADER

#if HAVE_CONFIG
#include "config.h"
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h> 
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <getopt.h>

/* const */

enum {R, G, B}; /* Red, Green, Blue */

#define HEADER
#define BPP           32  /* max number of bits per pixel */
#define TIME_INTERVAL 250 /* ms */
#define FILE_OUT      "out.bmp"
#define SIN30         0.5             /* sin(30) */
#define COS30         0.866025403784438646763723170754 /* cos(30) */
#define BORDER        5 /* pixel */

#if SDL_BYTEORDER == SDL_BIG_ENDIAN
  #define    rmask  0xff000000
  #define    gmask  0x00ff0000
  #define    bmask  0x0000ff00
  #define    amask  0x000000ff
#else
  #define    rmask  0x000000ff
  #define    gmask  0x0000ff00
  #define    bmask  0x00ff0000
  #define    amask  0xff000000
#endif

/* macro */

#define Min(a,b)  ((a) < (b))? (a) : (b)
#define Ind(x,y)  ((x)*(M->c) + (y))
#define Lx(index) (Dt * D->m[index] / (float)(Dx*Dx*255))
#define Ly(index) (Dt * D->m[index] / (float)(Dy*Dy*255))

/* global variables */

SDL_Rect background;

static Uint32 full_screen = 0;
static int mode3d = 0, implicit = 1;

/* structure definition */

typedef struct {
  int color; /* R G or B */
  int r, c;  /* matrix dimenction */
  Uint8 *m;
}Matrice;

typedef struct {
  int r, c;
}Limit;

static struct option long_options[] = {
  {"3d",          no_argument,       &mode3d, 1},
  {"expicit",     no_argument,       &implicit, 0},
  {"fullscreen",  no_argument,       0, 'f'},
  {"help",        no_argument,       0, 'h'},
  {"version",     no_argument,       0, 'v'},
  {"multicolor",  no_argument,       0, 'm'},
  {"dx",          required_argument, 0, 'x'},
  {"dy",          required_argument, 0, 'y'},
  {"dt",          required_argument, 0, 't'},
  {"steps",       required_argument, 0, 's'},
  {"output",      required_argument, 0, 'o'},
  {"delay",       required_argument, 0, 'd'},
  {"Width",       required_argument, 0, 'W'},
  {"Height",      required_argument, 0, 'H'},
  {0, 0, 0, 0}
};


#endif
